% lab12_ex_adapt_todo.m 
%
% ADAPTIVE FILTER - todo
%
% TASK #1 - adaptive interference cancelling (AIC)
%
% Run program lab12_ex_adapt.m changing main options:
% itask = 1  for  env = 0,1  and  for ialg = 1,2,3.
% Observe results. Try to understand them.
% In task #1:
%    d(n) = s(n) + o1(n)
%    x(n) = o2(n)
% we would like to remove from d(n) oscillatory interference o1(n) which has added
% to our signal s(n). o2(n) is a reference interference pattern, similar to o1(n),
% recorded separately by another microphone.
% The role of the filter is adjust o2(n) to o1(n), in time (delay) and in amplitude,
% and subtract it.
% Examples of d(n):
% s(n) pilot speaking to the microphone in the airplane cockpit, o1(n) engine disturbance,
% s(n) ECG of a still unborn child, o1(n) ECG of the mother,
% s(n) your voice, o1(n) interfering sound
% QUESTIONS
% What is the maximum permitted values of mi? It is calculated.
% Try different values of mi, smaller and bigger.
% Is the final filter h(n) similar to the optimal Wiener filter h_opt(n)?
%
% TASK #2 - adaptive interference (NOISE) cancelling for real signals (ANC)
%
% Separately record speech and vibrating sound of any machine/engine.
% Create two signals:   d(n) = speech(n) + filtered( vibration(n) ),
%                       x(n) = vibration(n).
% For filter use, for example, h = [ 0 0.75 0 0.25 ] and fv=filter(h,1,v).
% The filter should change amplitudes and delays of the vibration frequencies.
% Does the filter work?
%
% TASK #3 - adaptive echo cancellation for real signals (AEC)
%
% This is the same working scenario as above:
%    d(n) = myvoice(n) + echo_from_loudspeaker(n),     d(n) = speakerA(n) + echoB(n),
%    x(n) = signal_sent_to_loudspeaker(n),             d(n) = speakerB(n),
% which is typical for tele-conference systems, e.g. speaking by phone in a car.
% 
% Record two clear speech fragments sA(n) and sB(n) lasting approx. 5-10 sec
% or take them from internet.
% Create two signals:   d(n) = delayed_1sec( sA(n) ) + filtered( sB(n) ),
%                       x(n) = sB(n).
% As a filter use, for example, h = [ 0 0 1 0 0 0.5 0 0 0.25 ].
% Will the adaptive filter converge to h?
% Try to find in the internet impulse response of any room or use impulse_resp_11kHz.wav.
% Is the filter working properly?
%
% TASK #4 - Adaptive line enhancement (ALE), de-noising 
%
% Run program lab12_ex_adapt.m, changing its main options as follows:
% itask = 2  for  env = 1  and  for ialg = 1,2,3.
% Observe results. Try to understand them.
% In task #4:
%    d(n) = s(n)
%    x(n) = s(n-1)
% we would like to predict s(n) having s(n-1).
% Since only deterministic components of s(n) can be predicted, the filter should
% adjust peaks of its frequency response to these components and ...
% to improve the signal SNR (Signal-to-Noise). 
%
% Un-comment two figures in the adaptation loop:
% subplot(211); stem(h); xlabel('n'); title('h(n)'); grid;
% subplot(212); plot(f,abs(freqz(h,1,f,fs))); xlabel(' f [Hz]'); title('|H(f)|'); grid; pause(0.25);
% Observe how the filter h(n) is changing its shape and track the signal frequency
% in its frequency response.
% Has the signal SNR been improved via ALE algorithm?
%
% TASK #5 - Adaptive line enhancement (ALE) for real signals
%
% Apply ALE algorithm to recorded noisy speech signals.
% You can add noise to good clear recordings.
